/* A Bison parser, made by GNU Bison 3.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 38 "./bvl_bcomp_y.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mut.h"
#include "aut.h"
#include "abl.h"
#include "bdd.h"
#include "abe.h"

#include "bvl_utype.h"
#include "bvl_util.h"
#include "bvl_byacc.h"
#include "bvl_bedef.h"
#include "bvl_bspec.h"

extern  int   yylex     ( );
extern  void  yyerror   ( );


#line 91 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    tok_AND = 258,
    PRAGMA = 259,
    _BEGIN = 260,
    _END = 261,
    _EQSym = 262,
    _EXIT = 263,
    _FILE = 264,
    _GESym = 265,
    _GTSym = 266,
    _IN = 267,
    _INOUT = 268,
    _LABEL = 269,
    _LESym = 270,
    _LINKAGE = 271,
    _LTSym = 272,
    _NAND = 273,
    _NESym = 274,
    _NEXT = 275,
    _NOR = 276,
    _NOT = 277,
    tok_NULL = 278,
    _OR = 279,
    _OUT = 280,
    _XOR = 281,
    ABS = 282,
    ACCESS = 283,
    AFTER = 284,
    ALIAS = 285,
    ALL = 286,
    ARCHITECTURE = 287,
    ARRAY = 288,
    ASSERT = 289,
    ATTRIBUTE = 290,
    AbstractLit = 291,
    Ampersand = 292,
    Apostrophe = 293,
    Arrow = 294,
    BIT = 295,
    BIT_VECTOR = 296,
    _BLOCK = 297,
    BODY = 298,
    BUFFER = 299,
    BUS = 300,
    Bar = 301,
    BasedInt = 302,
    BasedReal = 303,
    BitStringLit = 304,
    Box = 305,
    CASE = 306,
    COMPONENT = 307,
    CONFIGURATION = 308,
    CONSTANT = 309,
    CharacterLit = 310,
    Colon = 311,
    Comma = 312,
    DISCONNECT = 313,
    DOWNTO = 314,
    DecimalInt = 315,
    DecimalReal = 316,
    Dot = 317,
    DoubleStar = 318,
    ELSE = 319,
    ELSIF = 320,
    ENTITY = 321,
    ERROR = 322,
    FOR = 323,
    FUNCTION = 324,
    GENERATE = 325,
    GENERIC = 326,
    GUARDED = 327,
    IF = 328,
    IS = 329,
    Identifier = 330,
    LIBRARY = 331,
    LOOP = 332,
    LeftParen = 333,
    MAP = 334,
    MOD = 335,
    MUX_BIT = 336,
    MUX_VECTOR = 337,
    Minus = 338,
    NATURAL = 339,
    NATURAL_VECTOR = 340,
    NEW = 341,
    OF = 342,
    ON = 343,
    OPEN = 344,
    OTHERS = 345,
    _PACKAGE = 346,
    PORT = 347,
    PROCEDURE = 348,
    PROCESS = 349,
    Plus = 350,
    _PS = 351,
    _NS = 352,
    _US = 353,
    _MS = 354,
    RANGE = 355,
    RECORD = 356,
    REG_BIT = 357,
    REG_VECTOR = 358,
    REGISTER = 359,
    REM = 360,
    REPORT = 361,
    RETURN = 362,
    RightParen = 363,
    SELECT = 364,
    SEVERITY = 365,
    SIGNAL = 366,
    _STABLE = 367,
    SUBTYPE = 368,
    Semicolon = 369,
    Slash = 370,
    Star = 371,
    StringLit = 372,
    THEN = 373,
    TO = 374,
    TRANSPORT = 375,
    _TYPE = 376,
    UNITS = 377,
    UNTIL = 378,
    USE = 379,
    VARIABLE = 380,
    VarAsgn = 381,
    WAIT = 382,
    WARNING = 383,
    WHEN = 384,
    WHILE = 385,
    WITH = 386,
    WOR_BIT = 387,
    WOR_VECTOR = 388
  };
#endif
/* Tokens.  */
#define tok_AND 258
#define PRAGMA 259
#define _BEGIN 260
#define _END 261
#define _EQSym 262
#define _EXIT 263
#define _FILE 264
#define _GESym 265
#define _GTSym 266
#define _IN 267
#define _INOUT 268
#define _LABEL 269
#define _LESym 270
#define _LINKAGE 271
#define _LTSym 272
#define _NAND 273
#define _NESym 274
#define _NEXT 275
#define _NOR 276
#define _NOT 277
#define tok_NULL 278
#define _OR 279
#define _OUT 280
#define _XOR 281
#define ABS 282
#define ACCESS 283
#define AFTER 284
#define ALIAS 285
#define ALL 286
#define ARCHITECTURE 287
#define ARRAY 288
#define ASSERT 289
#define ATTRIBUTE 290
#define AbstractLit 291
#define Ampersand 292
#define Apostrophe 293
#define Arrow 294
#define BIT 295
#define BIT_VECTOR 296
#define _BLOCK 297
#define BODY 298
#define BUFFER 299
#define BUS 300
#define Bar 301
#define BasedInt 302
#define BasedReal 303
#define BitStringLit 304
#define Box 305
#define CASE 306
#define COMPONENT 307
#define CONFIGURATION 308
#define CONSTANT 309
#define CharacterLit 310
#define Colon 311
#define Comma 312
#define DISCONNECT 313
#define DOWNTO 314
#define DecimalInt 315
#define DecimalReal 316
#define Dot 317
#define DoubleStar 318
#define ELSE 319
#define ELSIF 320
#define ENTITY 321
#define ERROR 322
#define FOR 323
#define FUNCTION 324
#define GENERATE 325
#define GENERIC 326
#define GUARDED 327
#define IF 328
#define IS 329
#define Identifier 330
#define LIBRARY 331
#define LOOP 332
#define LeftParen 333
#define MAP 334
#define MOD 335
#define MUX_BIT 336
#define MUX_VECTOR 337
#define Minus 338
#define NATURAL 339
#define NATURAL_VECTOR 340
#define NEW 341
#define OF 342
#define ON 343
#define OPEN 344
#define OTHERS 345
#define _PACKAGE 346
#define PORT 347
#define PROCEDURE 348
#define PROCESS 349
#define Plus 350
#define _PS 351
#define _NS 352
#define _US 353
#define _MS 354
#define RANGE 355
#define RECORD 356
#define REG_BIT 357
#define REG_VECTOR 358
#define REGISTER 359
#define REM 360
#define REPORT 361
#define RETURN 362
#define RightParen 363
#define SELECT 364
#define SEVERITY 365
#define SIGNAL 366
#define _STABLE 367
#define SUBTYPE 368
#define Semicolon 369
#define Slash 370
#define Star 371
#define StringLit 372
#define THEN 373
#define TO 374
#define TRANSPORT 375
#define _TYPE 376
#define UNITS 377
#define UNTIL 378
#define USE 379
#define VARIABLE 380
#define VarAsgn 381
#define WAIT 382
#define WARNING 383
#define WHEN 384
#define WHILE 385
#define WITH 386
#define WOR_BIT 387
#define WOR_VECTOR 388

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 59 "./bvl_bcomp_y.y"

	long		 valu;
	char		*text;
        bvl_ablstr       list;
	bvl_name	 name;
        struct g_type dble;
	

#line 418 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   240

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  134
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  102
/* YYNRULES -- Number of rules.  */
#define YYNRULES  180
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  287

#define YYUNDEFTOK  2
#define YYMAXUTOK   388


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   261,   261,   261,   358,   355,   371,   379,   380,   388,
     393,   400,   405,   406,   412,   435,   451,   456,   464,   470,
     468,   482,   483,   496,   502,   507,   512,   519,   537,   539,
     544,   545,   549,   554,   561,   566,   567,   573,   611,   628,
     629,   634,   635,   637,   639,   649,   644,   663,   669,   673,
     674,   679,   680,   681,   682,   688,   702,   723,   729,   771,
     772,   774,   779,   783,   784,   789,   790,   791,   792,   802,
     798,   824,   828,   838,   842,   849,   850,   857,   861,   865,
     880,  1130,  1131,  1154,  1152,  1390,  1391,  1398,  1413,  1418,
    1427,  1428,  1434,  1441,  1442,  1444,  1446,  1448,  1454,  1453,
    1460,  1461,  1472,  1474,  1476,  1548,  1549,  1556,  1557,  1563,
    1568,  1570,  1575,  1577,  1579,  1581,  1586,  1590,  1597,  1601,
    1608,  1610,  1614,  1622,  1626,  1633,  1635,  1642,  1647,  1649,
    1657,  1662,  1664,  1670,  1676,  1678,  1773,  1775,  1780,  1782,
    1784,  1789,  1796,  1802,  1804,  1806,  1811,  1823,  1841,  1905,
    1909,  1911,  1913,  1915,  1917,  1919,  1921,  1923,  1925,  1927,
    1933,  1932,  1938,  1939,  1947,  1948,  1954,  1955,  1960,  1968,
    1969,  1975,  1976,  1981,  1986,  1991,  2000,  2005,  2010,  2015,
    2020
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tok_AND", "PRAGMA", "_BEGIN", "_END",
  "_EQSym", "_EXIT", "_FILE", "_GESym", "_GTSym", "_IN", "_INOUT",
  "_LABEL", "_LESym", "_LINKAGE", "_LTSym", "_NAND", "_NESym", "_NEXT",
  "_NOR", "_NOT", "tok_NULL", "_OR", "_OUT", "_XOR", "ABS", "ACCESS",
  "AFTER", "ALIAS", "ALL", "ARCHITECTURE", "ARRAY", "ASSERT", "ATTRIBUTE",
  "AbstractLit", "Ampersand", "Apostrophe", "Arrow", "BIT", "BIT_VECTOR",
  "_BLOCK", "BODY", "BUFFER", "BUS", "Bar", "BasedInt", "BasedReal",
  "BitStringLit", "Box", "CASE", "COMPONENT", "CONFIGURATION", "CONSTANT",
  "CharacterLit", "Colon", "Comma", "DISCONNECT", "DOWNTO", "DecimalInt",
  "DecimalReal", "Dot", "DoubleStar", "ELSE", "ELSIF", "ENTITY", "ERROR",
  "FOR", "FUNCTION", "GENERATE", "GENERIC", "GUARDED", "IF", "IS",
  "Identifier", "LIBRARY", "LOOP", "LeftParen", "MAP", "MOD", "MUX_BIT",
  "MUX_VECTOR", "Minus", "NATURAL", "NATURAL_VECTOR", "NEW", "OF", "ON",
  "OPEN", "OTHERS", "_PACKAGE", "PORT", "PROCEDURE", "PROCESS", "Plus",
  "_PS", "_NS", "_US", "_MS", "RANGE", "RECORD", "REG_BIT", "REG_VECTOR",
  "REGISTER", "REM", "REPORT", "RETURN", "RightParen", "SELECT",
  "SEVERITY", "SIGNAL", "_STABLE", "SUBTYPE", "Semicolon", "Slash", "Star",
  "StringLit", "THEN", "TO", "TRANSPORT", "_TYPE", "UNITS", "UNTIL", "USE",
  "VARIABLE", "VarAsgn", "WAIT", "WARNING", "WHEN", "WHILE", "WITH",
  "WOR_BIT", "WOR_VECTOR", "$accept", "design_file", "$@1",
  "entity_declaration", "$@2", ".generic_clause.", "generic_clause",
  "formal_generic_list", "...formal_generic_element..",
  "formal_generic_element", "generic_VarAsgn__expression",
  "generic_expression", "generic_aggregate", "$@3",
  "...generic_element_association..", "generic_element_association",
  ".constraint.", "constraint", "range", "direction", ".port_clause.",
  "port_clause", "formal_port_list", "...formal_port_element..",
  "formal_port_element", ".SIGNAL.", ".mode.", "architecture_body", "$@4",
  "architecture_declarative_part", "..block_declarative_item..",
  "block_declarative_item", "pragma_declaration", "constant_declaration",
  "constant_VarAsgn__expression", "signal_declaration", ".signal_kind.",
  "architecture_statement_part", "..concurrent_statement..",
  "concurrent_statement", "block_statement", "$@5", "set_of_statements",
  "concurrent_assertion_statement",
  "concurrent_signal_assignment_statement",
  "unlabeled_concurrent_assertion_statement", "assertion_statement",
  "unlabeled_conditional_signal_assignment",
  "..waveform__WHEN__condition__ELSE..",
  "unlabeled_selected_signal_assignment", "$@6",
  "...waveform__WHEN__choices..", "waveform__WHEN__choices", "waveform",
  "waveform_element", ".AFTER__delay_expression.", "delay_expression",
  ".time_unit.", "choices", "$@7", "..Bar__choice..", "choice",
  ".REPORT__expression.", ".SEVERITY__expression.", "report__message",
  "severity__message", "expression", "relation..AND__relation..",
  "relation..OR__relation..", "relation.NAND_NOR__relation.",
  "relation..XOR__relation..", "relation", "simple_expression",
  ".sign.term..add_op__term..", "term", "factor", "primary",
  "relational_operator", "literal", "aggregate", "name", "indexed_name",
  "slice_name", "attribute_name", "attribute_designator", "type_mark",
  "identifier_list", "$@8", "...identifier..", ".label.",
  ".guard_expression.", "guard_expression", ".GUARDED.", ".simple_name.",
  "simple_name", "target", "a_label", "label", "abstractlit",
  "RightParen_ERR", "Semicolon_ERR", "END_ERR", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388
};
# endif

#define YYPACT_NINF (-177)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-177)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -177,    53,    -7,  -177,    25,    28,  -177,  -177,   -17,    26,
    -177,  -177,  -177,   -25,    -8,    20,     5,   -26,  -177,    31,
     -41,    36,    21,   102,  -177,  -177,  -177,  -177,  -177,    39,
       8,  -177,   -41,     4,  -177,    20,  -177,  -177,    63,  -177,
     -41,   -41,  -177,  -177,  -177,     8,  -177,    39,   -41,  -177,
     116,    16,  -177,   -10,  -177,    36,   -41,   -41,    75,  -177,
    -177,   -41,  -177,    61,    39,  -177,  -177,  -177,  -177,    82,
    -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,
      64,  -177,  -177,     4,   112,   102,    12,  -177,    89,    90,
      72,   113,    34,  -177,  -177,  -177,  -177,  -177,   -10,    20,
     -41,   -11,    96,   -11,  -177,  -177,  -177,  -177,  -177,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,     2,   139,   -27,   106,
     -10,   -10,  -177,  -177,     8,    -9,     6,  -177,    64,   -41,
    -177,     3,  -177,  -177,   -11,  -177,    57,   161,   142,  -177,
     141,   114,   134,   132,  -177,  -177,  -177,  -177,  -177,  -177,
    -177,    58,   113,    99,    94,  -177,  -177,  -177,  -177,    64,
      64,  -177,  -177,  -177,   113,   113,  -177,  -177,  -177,   -13,
    -177,  -177,    65,    62,    67,   -11,   -11,   -11,   -11,   -11,
     -11,   -11,   -11,  -177,  -177,   -11,   -11,    66,  -177,  -177,
     -23,  -177,  -177,   -11,   169,  -177,    52,   -13,  -177,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,  -177,   -39,   -41,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,    20,
     113,  -177,   -11,     8,  -177,    -4,   -41,   -41,  -177,  -177,
    -177,  -177,  -177,   165,     8,    -3,  -177,   153,  -177,  -177,
    -177,  -177,  -177,    -1,    99,  -177,   -11,  -177,   113,  -177,
      13,   102,   113,  -177,   -11,   119,  -177,    60,   144,  -177,
    -177,    55,  -177,  -177,  -177,  -177,  -177,  -177,   115,    -2,
     -14,  -177,   -41,  -177,   -11,  -177,  -177,  -177,  -177,  -177,
    -177,  -177,  -177,  -177,   143,   -14,  -177
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     0,     1,     0,     0,     6,   173,     0,     0,
       3,     4,    47,     0,     7,     0,     0,    30,     8,     0,
       0,     0,     0,     0,    31,    45,   179,    10,    15,     0,
       0,    12,     0,     0,   180,   171,    49,   160,     0,   178,
       0,    11,    33,    38,    40,     0,    35,     0,     0,   172,
       0,     0,   162,     0,     9,     0,     0,    34,     0,     5,
      63,     0,    55,     0,     0,    50,    52,    53,    51,   161,
     150,   153,   152,   155,   158,   159,   156,   157,   151,   154,
      24,    13,    32,     0,    41,     0,     0,    54,     0,     0,
       0,     0,     0,    25,    36,    42,    44,    43,     0,   171,
       0,     0,   173,     0,    64,    65,    66,    67,    73,    78,
      75,    77,   174,   143,   144,   145,   142,     0,     0,     0,
       0,     0,   163,   177,     0,     0,     0,    14,    24,     0,
      68,     0,   140,   138,     0,   139,   105,   112,   113,   114,
     115,   120,   125,   127,   128,   130,   131,   133,   134,   135,
      83,     0,     0,   169,   166,    72,    74,    76,   175,    24,
      24,    26,    29,    28,     0,     0,    16,    18,    17,    59,
      46,   132,     0,     0,   107,     0,     0,     0,     0,     0,
       0,     0,     0,   136,   137,     0,     0,     0,   149,   148,
       0,   170,    81,     0,     0,   167,     0,    59,    27,    19,
      23,    61,    60,    37,   141,   109,   106,     0,     0,   117,
     119,   124,   116,   121,   122,   118,   123,   126,   129,     0,
       0,   146,     0,     0,    69,     0,     0,     0,    21,   110,
     111,   108,    79,     0,     0,     0,    88,    90,   168,    63,
      57,    56,    58,     0,   169,   147,     0,    80,     0,    89,
       0,     0,     0,    20,     0,     0,    91,    93,     0,    22,
      85,     0,    82,    94,    95,    96,    97,    92,   164,     0,
       0,   176,     0,   165,     0,    84,   103,    87,    98,   102,
     104,    70,    86,   100,    99,     0,   101
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,   133,
    -177,  -177,  -177,  -177,  -177,   -65,   -30,  -177,  -177,     1,
    -177,  -177,  -177,  -177,   110,  -177,  -177,  -177,  -177,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,     0,  -177,   -43,  -177,
    -177,  -177,  -177,  -177,  -177,    80,  -177,    81,  -177,    84,
    -177,  -177,   -62,    -6,  -177,  -177,  -177,  -177,  -177,  -177,
    -177,   -72,  -177,  -177,  -177,  -177,   -91,  -177,  -177,  -177,
    -177,    29,    32,  -177,    33,  -177,    83,  -177,  -176,  -177,
     -85,  -177,  -177,  -177,  -177,    30,    22,  -177,  -177,  -177,
    -177,  -177,   -29,   121,    19,     7,  -177,   -50,   -87,   -42,
     -32,   -83
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     5,    14,    17,    18,    30,    41,    31,
     127,   166,   167,   228,   243,   199,    92,    93,   124,   164,
      23,    24,    45,    57,    46,    47,    98,    10,    36,    50,
      51,    65,    66,    67,   226,    68,   203,    85,    86,   104,
     105,   239,   251,   106,   107,   108,   109,   110,   222,   111,
     187,   269,   260,   261,   236,   249,   256,   267,   277,   283,
     284,   278,   174,   208,   206,   231,   237,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   185,   147,   148,
     149,   113,   114,   115,   189,    80,    38,    52,    69,   272,
     194,   195,   192,    48,   116,   117,   118,   119,   200,    40,
      27,    35
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      42,   112,    99,    56,   125,    43,    20,   101,    54,    55,
     136,   131,   150,   100,   100,   154,    59,    61,   -62,   -71,
      62,   -48,    32,     8,    82,    83,     6,    12,   229,    87,
      70,    71,   201,   112,    19,   132,   162,    28,   132,   168,
     151,   133,   123,   172,   133,   132,   101,   101,     7,   240,
     162,   133,   132,     3,    49,   274,   252,    11,   133,     4,
       9,     7,    15,    16,     7,   190,    22,   134,   130,    58,
      63,    72,    73,    26,    74,    75,   276,   198,     7,   -39,
     152,   134,   161,    21,   165,    39,    89,   102,   102,   230,
      29,   202,    76,    77,   279,     7,   163,   170,   169,    33,
       7,    13,   223,   135,   103,    25,   135,    39,    34,   279,
     163,    26,    26,   135,    37,    44,    39,   178,    49,    53,
     135,    60,    78,    79,    95,    96,   246,    64,   128,   196,
     197,    84,   179,   234,   112,   180,    88,    97,   181,    90,
     182,   183,    91,   103,   103,   120,   121,   122,   221,   123,
     159,   160,  -176,   184,   153,   255,   263,   264,   265,   266,
     126,   257,   158,   173,   175,   112,   176,   177,   258,   186,
     188,   191,   193,   204,   224,   219,   232,   207,   225,   205,
     244,   238,   248,   262,   270,   280,   268,   259,    81,   285,
     271,   220,   245,    94,   241,   242,   250,   227,   155,   156,
     280,   253,   157,   247,   209,   210,   211,   212,   213,   214,
     215,   216,   282,   286,   171,   254,   235,   217,   273,   218,
     129,     0,     0,     0,     0,     0,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   275,     0,     0,
     281
};

static const yytype_int16 yycheck[] =
{
      32,    86,    85,    45,    91,     1,     1,    34,    40,    41,
     101,    22,   103,     1,     1,    42,    48,     1,     6,     6,
       4,     5,     1,     4,    56,    57,     1,     1,    67,    61,
      40,    41,    45,   118,    15,    49,    59,     1,    49,   126,
      38,    55,    36,   134,    55,    49,    34,    34,    75,   225,
      59,    55,    49,     0,    35,    57,    57,    74,    55,    66,
      32,    75,    87,    71,    75,   152,    92,    78,   100,    47,
      54,    81,    82,   114,    84,    85,    90,   164,    75,    75,
      78,    78,   124,    78,    78,   108,    64,    75,    75,   128,
      54,   104,   102,   103,   270,    75,   119,   129,   128,    78,
      75,    75,   193,   117,   131,    74,   117,   108,     6,   285,
     119,   114,   114,   117,    75,   111,   108,     3,    99,    56,
     117,     5,   132,   133,    12,    13,   129,   111,    98,   159,
     160,    56,    18,   220,   219,    21,    75,    25,    24,    57,
      26,     7,    78,   131,   131,    56,    56,    75,   190,    36,
     120,   121,    56,    19,    15,   246,    96,    97,    98,    99,
     126,   248,    56,   106,     3,   250,    24,    26,   251,    37,
     112,    72,    78,   108,     5,   109,   208,   110,   126,   117,
      15,   223,    29,    64,   129,   270,    42,   252,    55,    46,
      75,   190,   234,    83,   226,   227,   239,   197,   118,   118,
     285,   243,   118,   235,   175,   176,   177,   178,   179,   180,
     181,   182,   274,   285,   131,   244,   222,   185,   268,   186,
      99,    -1,    -1,    -1,    -1,    -1,   219,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   269,    -1,    -1,
     272
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   135,   136,     0,    66,   137,     1,    75,   228,    32,
     161,    74,     1,    75,   138,    87,    71,   139,   140,   228,
       1,    78,    92,   154,   155,    74,   114,   234,     1,    54,
     141,   143,     1,    78,     6,   235,   162,    75,   220,   108,
     233,   142,   234,     1,   111,   156,   158,   159,   227,   228,
     163,   164,   221,    56,   234,   234,   233,   157,   220,   234,
       5,     1,     4,    54,   111,   165,   166,   167,   169,   222,
      40,    41,    81,    82,    84,    85,   102,   103,   132,   133,
     219,   143,   234,   234,    56,   171,   172,   234,    75,   220,
      57,    78,   150,   151,   158,    12,    13,    25,   160,   235,
       1,    34,    75,   131,   173,   174,   177,   178,   179,   180,
     181,   183,   214,   215,   216,   217,   228,   229,   230,   231,
      56,    56,    75,    36,   152,   232,   126,   144,   219,   227,
     234,    22,    49,    55,    78,   117,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   212,   213,   214,
     200,    38,    78,    15,    42,   179,   181,   183,    56,   219,
     219,   233,    59,   119,   153,    78,   145,   146,   232,   150,
     234,   210,   200,   106,   196,     3,    24,    26,     3,    18,
      21,    24,    26,     7,    19,   211,    37,   184,   112,   218,
     232,    72,   226,    78,   224,   225,   150,   150,   232,   149,
     232,    45,   104,   170,   108,   117,   198,   110,   197,   205,
     205,   205,   205,   205,   205,   205,   205,   206,   208,   109,
     153,   233,   182,   200,     5,   126,   168,   170,   147,    67,
     128,   199,   234,   229,   232,   187,   188,   200,   233,   175,
     212,   234,   234,   148,    15,   233,   129,   234,    29,   189,
     172,   176,    57,   233,   226,   200,   190,   232,   235,   149,
     186,   187,    64,    96,    97,    98,    99,   191,    42,   185,
     129,    75,   223,   231,    57,   234,    90,   192,   195,   212,
     214,   234,   186,   193,   194,    46,   195
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   134,   136,   135,   138,   137,   137,   139,   139,   140,
     140,   141,   142,   142,   143,   143,   144,   145,   145,   147,
     146,   148,   148,   149,   150,   150,   151,   152,   153,   153,
     154,   154,   155,   155,   156,   157,   157,   158,   158,   159,
     159,   160,   160,   160,   160,   162,   161,   161,   163,   164,
     164,   165,   165,   165,   165,   166,   167,   168,   169,   170,
     170,   170,   171,   172,   172,   173,   173,   173,   173,   175,
     174,   176,   177,   177,   178,   178,   178,   178,   179,   180,
     181,   182,   182,   184,   183,   185,   185,   186,   187,   188,
     189,   189,   190,   191,   191,   191,   191,   191,   193,   192,
     194,   194,   195,   195,   195,   196,   196,   197,   197,   198,
     199,   199,   200,   200,   200,   200,   201,   201,   202,   202,
     203,   203,   203,   204,   204,   205,   205,   206,   207,   207,
     208,   209,   209,   210,   210,   210,   211,   211,   212,   212,
     212,   213,   214,   214,   214,   214,   215,   216,   217,   218,
     219,   219,   219,   219,   219,   219,   219,   219,   219,   219,
     221,   220,   222,   222,   223,   223,   224,   224,   225,   226,
     226,   227,   227,   228,   229,   230,   231,   232,   233,   234,
     235
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     9,     2,     0,     1,     5,
       3,     2,     0,     3,     6,     1,     2,     1,     1,     0,
       5,     0,     3,     1,     0,     1,     3,     3,     1,     1,
       0,     1,     5,     3,     2,     0,     3,     7,     1,     0,
       1,     0,     1,     1,     1,     0,    12,     2,     1,     0,
       2,     1,     1,     1,     2,     1,     7,     2,     7,     0,
       1,     1,     1,     0,     2,     1,     1,     1,     2,     0,
      10,     1,     2,     1,     2,     1,     2,     1,     1,     5,
       6,     0,     5,     0,    10,     0,     3,     3,     1,     2,
       0,     2,     2,     0,     1,     1,     1,     1,     0,     3,
       0,     3,     1,     1,     1,     0,     2,     0,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     1,     1,     3,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     4,     6,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     3,     0,     3,     0,     1,     0,     1,     3,     0,
       1,     0,     1,     1,     1,     2,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 261 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*    Initializations					*/
		/*      - erroneous description presumed !		*/
		/* ###----------------------------------------------### */

		BVL_NM1LST = NULL;
		BVL_GRDLST = NULL;
		BVL_CNDLST = NULL;
		BVL_VALLST = NULL;
		BVL_ERRFLG = 0;

		dic                = beh_initab ();
		BVL_BEFPNT         = beh_addbefig (BVL_HEDFIG,NULL);
		BVL_BEFPNT->ERRFLG = 1;
		BVL_HEDFIG         = BVL_BEFPNT;
		}
#line 1879 "y.tab.c"
    break;

  case 3:
#line 280 "./bvl_bcomp_y.y"
                {
		struct beout *beout_pnt;
		struct beaux *beaux_pnt;
		struct bebus *bebus_pnt;
		struct bereg *bereg_pnt;
		struct berin *berin_pnt;
		struct beaux *beaux_pred;
		struct berin *berin_pred;

		/* ###----------------------------------------------### */
		/*    Checking that each output have at least one driver*/
		/* ###----------------------------------------------### */

		beout_pnt = BVL_BEFPNT->BEOUT;
		while (beout_pnt != NULL)
		  {
		  if (beout_pnt->ABL == NULL)
		    bvl_error (40, beout_pnt->NAME);
		  beout_pnt = beout_pnt->NEXT;
		  }

		beaux_pnt = BVL_BEFPNT->BEAUX;
      beaux_pred=NULL;
		while (beaux_pnt != NULL)
		  {
        if (beaux_pnt->ABL == NULL)
        {
          fprintf (stderr,"`%s` Warning %d line %ld :",BVL_CURFIL,40,BVL_LINNUM);
          fprintf (stderr,"signal `%s` never assigned\n",beaux_pnt->NAME);
          
          /*removing signal*/
          if ( beaux_pred ) beaux_pred->NEXT = beaux_pnt->NEXT;
          else BVL_BEFPNT->BEAUX = beaux_pnt->NEXT;

          /*removing other ref to signal*/
          berin_pred = NULL;
          for ( berin_pnt = BVL_BEFPNT->BERIN; berin_pnt; berin_pnt = berin_pnt->NEXT )
          {
             if ( berin_pnt->NAME == beaux_pnt->NAME )
             {
                 if ( berin_pred ) berin_pred->NEXT = berin_pnt->NEXT;
                 else BVL_BEFPNT->BERIN = berin_pnt->NEXT;
                 break;
             }
             berin_pred = berin_pnt;
          }
        }
        else beaux_pred = beaux_pnt;
		  beaux_pnt = beaux_pnt->NEXT;
		  }

		bebus_pnt = BVL_BEFPNT->BEBUS;
		while (bebus_pnt != NULL)
		  {
		  if (bebus_pnt->BIABL == NULL)
		    bvl_error (40, bebus_pnt->NAME);
		  bebus_pnt = bebus_pnt->NEXT;
		  }

		bereg_pnt = BVL_BEFPNT->BEREG;
		while (bereg_pnt != NULL)
		  {
		  if (bereg_pnt->BIABL == NULL)
		    bvl_error (40,bereg_pnt->NAME);
		  bereg_pnt = bereg_pnt->NEXT;
		  }

		if (BVL_ERRFLG == 0)
		  BVL_BEFPNT->ERRFLG = 0;

		beh_fretab (dic);
		}
#line 1956 "y.tab.c"
    break;

  case 4:
#line 358 "./bvl_bcomp_y.y"
                {
		BVL_BEFPNT->NAME = (yyvsp[-1].text);
		BVL_MODNAM       = (yyvsp[-1].text);
		}
#line 1965 "y.tab.c"
    break;

  case 5:
#line 367 "./bvl_bcomp_y.y"
                {
		if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-7].text)))
		  bvl_error (1,(yyvsp[-1].text));
		}
#line 1974 "y.tab.c"
    break;

  case 6:
#line 373 "./bvl_bcomp_y.y"
                {
		bvl_error (2,NULL);
		}
#line 1982 "y.tab.c"
    break;

  case 8:
#line 381 "./bvl_bcomp_y.y"
                {
		BVL_BEFPNT->BEGEN = BVL_GENPNT;
		BVL_GENPNT = NULL;
		}
#line 1991 "y.tab.c"
    break;

  case 10:
#line 396 "./bvl_bcomp_y.y"
                { bvl_error (74,NULL); }
#line 1997 "y.tab.c"
    break;

  case 14:
#line 418 "./bvl_bcomp_y.y"
                {
		char *type;

		if ((yyvsp[-1].name).FLAG == (yyvsp[-2].dble).FLAG)
		  {
		  BVL_NM1LST = reverse (BVL_NM1LST);
		  type = namealloc ("natural");
		  BVL_GENPNT = bvl_addgen (BVL_GENPNT,BVL_INTLST,BVL_NM1LST,
		                           type,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
		  }
		else
		  bvl_error (33,NULL);
		freechain (BVL_NM1LST);
		freechain (BVL_INTLST);
		BVL_NM1LST = NULL;
		BVL_INTLST = NULL;
		}
#line 2019 "y.tab.c"
    break;

  case 15:
#line 436 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*   The following 3 lines reject tokens until the	*/
		/* sync. token 'Semicolon' is found			*/
		/* ###----------------------------------------------### */

		do
		  yychar = yylex ();
		while ((yychar != Semicolon) && (yychar != 0));
		yyerrok;
		bvl_error (75,NULL);
		}
#line 2036 "y.tab.c"
    break;

  case 17:
#line 457 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (yyvsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST,(void *)ptlong);
		}
#line 2048 "y.tab.c"
    break;

  case 19:
#line 470 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (yyvsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST,(void *)ptlong);
		}
#line 2060 "y.tab.c"
    break;

  case 22:
#line 486 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (yyvsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST,(void *)ptlong);
		}
#line 2072 "y.tab.c"
    break;

  case 23:
#line 497 "./bvl_bcomp_y.y"
                {(yyval.valu) = (yyvsp[0].valu);}
#line 2078 "y.tab.c"
    break;

  case 24:
#line 502 "./bvl_bcomp_y.y"
                {
		(yyval.name).FLAG  = 'S';
		(yyval.name).LEFT  = -1;
		(yyval.name).RIGHT = -1;
		}
#line 2088 "y.tab.c"
    break;

  case 25:
#line 508 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 2094 "y.tab.c"
    break;

  case 26:
#line 515 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[-1].name); }
#line 2100 "y.tab.c"
    break;

  case 27:
#line 522 "./bvl_bcomp_y.y"
                {
		(yyval.name).FLAG  = 'A';
		(yyval.name).LEFT  = (yyvsp[-2].valu);
		(yyval.name).RIGHT = (yyvsp[0].valu);

		if ((((yyvsp[-2].valu) > (yyvsp[0].valu)) && ((yyvsp[-1].valu) == BVL_UPTDFN)) ||
		    (((yyvsp[-2].valu) < (yyvsp[0].valu)) && ((yyvsp[-1].valu) == BVL_DWTDFN)) ||
		    (((yyvsp[-2].valu) < 0 ) || ((yyvsp[-1].valu) < 0 )))
		  {
		  bvl_error (32,NULL);
		  }
		}
#line 2117 "y.tab.c"
    break;

  case 28:
#line 538 "./bvl_bcomp_y.y"
                { (yyval.valu) = BVL_UPTDFN; }
#line 2123 "y.tab.c"
    break;

  case 29:
#line 540 "./bvl_bcomp_y.y"
                { (yyval.valu) = BVL_DWTDFN; }
#line 2129 "y.tab.c"
    break;

  case 33:
#line 557 "./bvl_bcomp_y.y"
                { bvl_error (3,NULL); }
#line 2135 "y.tab.c"
    break;

  case 37:
#line 580 "./bvl_bcomp_y.y"
                {
		char *signame;
		long   sigconf;
		void *pnt;

		/* ###----------------------------------------------### */
		/*    First, check the validity of the declaration.	*/
		/* Then, for each port, create the apropriate set of	*/
		/* structures (berin, bepor, beout, bebus)		*/
		/* ###----------------------------------------------### */

		chkdcl ('P', (yyvsp[-3].valu), (yyvsp[-2].dble).VALU, (yyvsp[-2].dble).FLAG, (yyvsp[0].valu), (yyvsp[-1].name).FLAG, &sigconf);

		BVL_NM1LST = reverse (BVL_NM1LST);
		while (BVL_NM1LST != NULL)
		  {
		  signame = (char *)BVL_NM1LST->DATA;
		  if (beh_chktab (dic,signame,BVL_MODNAM,BVL_SIGDFN) != 0)
		    bvl_error (4,signame);

		  pnt = addstr (BVL_BEFPNT,'P',(yyvsp[-3].valu),(yyvsp[-2].dble).VALU,(yyvsp[-2].dble).FLAG,signame,
		                (yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);

		  beh_addtab (dic,signame,BVL_MODNAM,BVL_SIGDFN,sigconf);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_WMNDFN,(yyvsp[-1].name).LEFT);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_WMXDFN,(yyvsp[-1].name).RIGHT);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_PNTDFN,(long)pnt);

		  BVL_NM1LST = delchain (BVL_NM1LST, BVL_NM1LST);
		  }
		}
#line 2171 "y.tab.c"
    break;

  case 38:
#line 612 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*   The following 3 lines reject tokens until the	*/
		/* sync. token 'Semicolon' is found			*/
		/* ###----------------------------------------------### */

		do
		  yychar = yylex ();
		while ((yychar != Semicolon) && (yychar != 0));
		yyerrok;

		bvl_error (6,NULL);
		}
#line 2189 "y.tab.c"
    break;

  case 41:
#line 634 "./bvl_bcomp_y.y"
                { (yyval.valu) = _IN; }
#line 2195 "y.tab.c"
    break;

  case 42:
#line 636 "./bvl_bcomp_y.y"
                { (yyval.valu) = _IN; }
#line 2201 "y.tab.c"
    break;

  case 43:
#line 638 "./bvl_bcomp_y.y"
                { (yyval.valu) = _OUT; }
#line 2207 "y.tab.c"
    break;

  case 44:
#line 640 "./bvl_bcomp_y.y"
                { (yyval.valu) = _INOUT; }
#line 2213 "y.tab.c"
    break;

  case 45:
#line 649 "./bvl_bcomp_y.y"
                {
		if ((yyvsp[-1].text) != BVL_MODNAM)
		  bvl_error (1,(yyvsp[-1].text));
		}
#line 2222 "y.tab.c"
    break;

  case 46:
#line 659 "./bvl_bcomp_y.y"
                {
		if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-10].text)))
		  bvl_error (7,(yyvsp[-1].text));
		}
#line 2231 "y.tab.c"
    break;

  case 47:
#line 665 "./bvl_bcomp_y.y"
                { bvl_error (8,NULL); }
#line 2237 "y.tab.c"
    break;

  case 54:
#line 684 "./bvl_bcomp_y.y"
                { bvl_error (9,NULL); }
#line 2243 "y.tab.c"
    break;

  case 55:
#line 689 "./bvl_bcomp_y.y"
           {
             char pragma[30];
             char type  [100];
             char name  [100];

             sscanf((char *)(yyvsp[0].valu),"-- %s %s %s", pragma,type,name);

             BVL_BEFPNT->BEPGM = beh_addbepgm(BVL_BEFPNT->BEPGM,
                                              type,name,(void *)0);
           }
#line 2258 "y.tab.c"
    break;

  case 56:
#line 709 "./bvl_bcomp_y.y"
                {
		long sigconf;
		
		if (chkdcl ('C',0,(yyvsp[-3].dble).VALU,(yyvsp[-3].dble).FLAG,0,(yyvsp[-2].name).FLAG,&sigconf) == 0)
		  {
		  beh_addtab (dic,(yyvsp[-5].text),BVL_MODNAM,BVL_WMNDFN,(yyvsp[-2].name).LEFT);
		  beh_addtab (dic,(yyvsp[-5].text),BVL_MODNAM,BVL_WMXDFN,(yyvsp[-2].name).RIGHT);
		  beh_addtab (dic,(yyvsp[-5].text),BVL_MODNAM,BVL_SIGDFN,sigconf);
		  beh_addtab (dic,(yyvsp[-5].text),NULL,BVL_PNTDFN,(yyvsp[-1].text));
		  }
		}
#line 2274 "y.tab.c"
    break;

  case 57:
#line 725 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 2280 "y.tab.c"
    break;

  case 58:
#line 736 "./bvl_bcomp_y.y"
                {
		char *signame;
		long   sigconf;
		void *pnt;

        /*errflg =*/ chkdcl ('S',0,(yyvsp[-3].dble).VALU,(yyvsp[-3].dble).FLAG,(yyvsp[-1].valu),(yyvsp[-2].name).FLAG,&sigconf);

		/* ###----------------------------------------------### */
		/*    First, check the validity of the declaration.	*/
		/* Then, for each signal, create the apropriate set of	*/
		/* structures (berin, bereg, beaux, bebux)		*/
		/* ###----------------------------------------------### */

		BVL_NM1LST = reverse (BVL_NM1LST);
		while (BVL_NM1LST != NULL)
		  {
		  signame = (char *)BVL_NM1LST->DATA;
		  if (beh_chktab (dic,signame,BVL_MODNAM,BVL_SIGDFN) != 0)
		    bvl_error (10,signame);

		  pnt = addstr (BVL_BEFPNT,'S',0,(yyvsp[-3].dble).VALU,(yyvsp[-3].dble).FLAG,signame,
		                (yyvsp[-2].name).LEFT,(yyvsp[-2].name).RIGHT);

		  beh_addtab (dic,signame,BVL_MODNAM,BVL_SIGDFN,sigconf);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_WMNDFN,(yyvsp[-2].name).LEFT);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_WMXDFN,(yyvsp[-2].name).RIGHT);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_PNTDFN,(long)pnt);

		  BVL_NM1LST = delchain (BVL_NM1LST,BVL_NM1LST);
		  }
		}
#line 2316 "y.tab.c"
    break;

  case 59:
#line 771 "./bvl_bcomp_y.y"
                { (yyval.valu) = 0; }
#line 2322 "y.tab.c"
    break;

  case 60:
#line 773 "./bvl_bcomp_y.y"
                { (yyval.valu) = REGISTER; }
#line 2328 "y.tab.c"
    break;

  case 61:
#line 775 "./bvl_bcomp_y.y"
                { (yyval.valu) = BUS; }
#line 2334 "y.tab.c"
    break;

  case 68:
#line 794 "./bvl_bcomp_y.y"
                { bvl_error (18,NULL); }
#line 2340 "y.tab.c"
    break;

  case 69:
#line 802 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic,(yyvsp[-3].text),BVL_MODNAM,BVL_LBLDFN) != 0)
		  bvl_error (19,(yyvsp[-3].text));

		beh_addtab (dic,(yyvsp[-3].text),BVL_MODNAM,BVL_LBLDFN,1);
		if ((yyvsp[-1].text) != NULL)
		  BVL_GRDLST = addchain (BVL_GRDLST,(char *)(yyvsp[-1].text));
		}
#line 2353 "y.tab.c"
    break;

  case 70:
#line 815 "./bvl_bcomp_y.y"
                {
		if ((yyvsp[-7].text) != NULL)
		  BVL_GRDLST = delchain (BVL_GRDLST,BVL_GRDLST);
		if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-9].text)))
		  bvl_error (20,(yyvsp[-1].text));
		}
#line 2364 "y.tab.c"
    break;

  case 72:
#line 830 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN) != 0)
		  bvl_error (19,(yyvsp[-1].text));

		beh_addtab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN,1);
		if (BVL_ERRFLG == 0)
		  BVL_BEFPNT->BEMSG->LABEL = (yyvsp[-1].text);
		}
#line 2377 "y.tab.c"
    break;

  case 74:
#line 844 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN) != 0)
		  bvl_error (19,(yyvsp[-1].text));
		beh_addtab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN,1);
		}
#line 2387 "y.tab.c"
    break;

  case 76:
#line 852 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN) != 0)
		  bvl_error (19,(yyvsp[-1].text));
		beh_addtab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN,1);
		}
#line 2397 "y.tab.c"
    break;

  case 79:
#line 870 "./bvl_bcomp_y.y"
                {
		if (BVL_ERRFLG == 0)
		  {
		  BVL_BEFPNT->BEMSG = beh_addbemsg(BVL_BEFPNT->BEMSG,NULL,(yyvsp[-1].valu),
		                                   (yyvsp[-2].text),(yyvsp[-3].list).LIST_ABL->DATA,NULL);
		  }
		}
#line 2409 "y.tab.c"
    break;

  case 80:
#line 886 "./bvl_bcomp_y.y"
                {
		long             i;
		struct beout   *beout_pnt;
		struct bebus   *bebus_pnt;
		struct bereg   *bereg_pnt;
		struct beaux   *beaux_pnt;
		struct bebux   *bebux_pnt;
		struct chain   *abl_pnt;
		struct bvl_expr expr0;
		struct bvl_expr expr1;
		struct bvl_expr expr2;
		struct bvl_expr expr3;
		struct bvl_expr expr4;
		struct bvl_expr expr5;
		struct bvl_expr expr6;
		long             rev_flg = 0;
		long             left_bnd;
		long             right_bnd;
		long             left;
		long             right;
		long             in_bound;
		long             out_bound;
		long             sig_width;
		long             sig_conf;

		expr4 = (yyvsp[-1].list);

		while (BVL_CNDLST != NULL)
		  {
		  expr5 = *((bvl_ablstr *) BVL_CNDLST->DATA);
		  expr6 = *((bvl_ablstr *) BVL_VALLST->DATA);

		  expr0 = bvl_cpyablstr (expr5);
		  expr1 = bvl_crtabl (ABL_NOT , expr5, BVL_EMPSTR,-1,-1);
		  expr5 = expr0;
		  expr2 = bvl_crtabl (ANDM, expr4, expr1     ,-1,-1);
		  expr3 = bvl_crtabl (ANDM, expr6, expr5     ,-1,-1);
		  expr4 = bvl_crtabl (ABL_OR  , expr2, expr3     ,-1,-1);

		  BVL_CNDLST = delchain (BVL_CNDLST,BVL_CNDLST);
		  BVL_VALLST = delchain (BVL_VALLST,BVL_VALLST);
		  }

		left_bnd  = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_WMNDFN);
		right_bnd = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_WMXDFN);
		sig_conf  = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_SIGDFN);

		left  = (yyvsp[-5].name).LEFT;
		right = (yyvsp[-5].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  sig_width = right_bnd - left_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 0;
		    in_bound  = right_bnd - right;
		    out_bound = right_bnd - left;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 1;
		    in_bound  = right_bnd - left;
		    out_bound = right_bnd - right;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  }
		else
		  {
		  sig_width = left_bnd - right_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 1;
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 0;
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  }

		if ((out_bound - in_bound + 1) != expr4.WIDTH)
		  bvl_error (35,(yyvsp[-5].name).NAME);

		if (rev_flg == 1)
		  expr4.LIST_ABL = reverse (expr4.LIST_ABL);

		abl_pnt = expr4.LIST_ABL;

		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		    bvl_error (21,(yyvsp[-5].name).NAME);
		    break;

		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		    if ((yyvsp[-3].valu) == BVL_GRDDFN)
		      bvl_error (22,(yyvsp[-5].name).NAME);
		    beout_pnt = (struct beout *)
		                 beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beout_pnt->ABL != NULL)
		            bvl_error (39,beout_pnt->NAME);
		          else
		            beout_pnt->ABL = (struct chain *)abl_pnt->DATA;
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beout_pnt = beout_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bebus_pnt = (struct bebus *)
		                 beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebus_pnt->BINODE = beh_addbinode (bebus_pnt->BINODE,
		                                             NULL,NULL);
		          bebus_pnt->BIABL  = beh_addbiabl  (bebus_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebus_pnt = bebus_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_BITDFN + BVL_NORDFN):
		    if ((yyvsp[-3].valu) == BVL_GRDDFN)
		      bvl_error (22,(yyvsp[-5].name).NAME);
		    beaux_pnt = (struct beaux *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beaux_pnt->ABL != NULL)
		            bvl_error (39,beaux_pnt->NAME);
		          else
		            beaux_pnt->ABL = (struct chain *)abl_pnt->DATA;
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beaux_pnt = beaux_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_RBIDFN + BVL_REGDFN):
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bereg_pnt = (struct bereg *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bereg_pnt->BINODE = beh_addbinode (bereg_pnt->BINODE,
		                                             NULL,NULL);
		          bereg_pnt->BIABL  = beh_addbiabl  (bereg_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bereg_pnt = bereg_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_WORDFN + BVL_BUSDFN) :
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bebux_pnt = (struct bebux *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebux_pnt->BINODE = beh_addbinode (bebux_pnt->BINODE,
		                                             NULL,NULL);
		          bebux_pnt->BIABL  = beh_addbiabl  (bebux_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebux_pnt = bebux_pnt->NEXT;
		        }
		      }
		    break;

		  default :
		    bvl_error (17,(yyvsp[-5].name).NAME);
		    break;
		  }
		}
#line 2655 "y.tab.c"
    break;

  case 82:
#line 1136 "./bvl_bcomp_y.y"
                {
		struct bvl_expr *expr_pnt;

		expr_pnt           = (bvl_ablstr *)mbkalloc(sizeof(bvl_ablstr));
		expr_pnt->WIDTH    = (yyvsp[-1].list).WIDTH;
		expr_pnt->LIST_ABL = (yyvsp[-1].list).LIST_ABL;
		BVL_CNDLST         = addchain (BVL_CNDLST,(char *) expr_pnt);

		expr_pnt           = (bvl_ablstr *)mbkalloc(sizeof(bvl_ablstr));
		expr_pnt->WIDTH    = (yyvsp[-3].list).WIDTH;
		expr_pnt->LIST_ABL = (yyvsp[-3].list).LIST_ABL;
		BVL_VALLST         = addchain (BVL_VALLST,(char *) expr_pnt);
		}
#line 2673 "y.tab.c"
    break;

  case 83:
#line 1154 "./bvl_bcomp_y.y"
                {
		BVL_SLCEXP = (yyvsp[0].list);
		BVL_BDDPNT = NULL;
		}
#line 2682 "y.tab.c"
    break;

  case 84:
#line 1165 "./bvl_bcomp_y.y"
                {
		long             i;
		struct beout   *beout_pnt;
		struct bebus   *bebus_pnt;
		struct bereg   *bereg_pnt;
		struct beaux   *beaux_pnt;
		struct bebux   *bebux_pnt;
		struct chain   *abl_pnt;
		struct bvl_expr expr1;
		long             rev_flg = 0;
		long             left_bnd;
		long             right_bnd;
		long             left;
		long             right;
		long             in_bound;
		long             out_bound;
		long             sig_width;
		long             sig_conf;

		expr1 = bvl_crtabl (ABL_OR ,(yyvsp[-2].list) ,(yyvsp[-1].list),-1,-1);
		if (BVL_BDDPNT != getlogbddnodeone())
		  bvl_error (25,NULL);
		left_bnd  = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_WMNDFN);
		right_bnd = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_WMXDFN);
		sig_conf  = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_SIGDFN);

		left  = (yyvsp[-5].name).LEFT;
		right = (yyvsp[-5].name).RIGHT;
		if (left_bnd <= right_bnd)
		  {
		  sig_width = right_bnd - left_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 0;
		    in_bound  = right_bnd - right;
		    out_bound = right_bnd - left;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 1;
		    in_bound  = right_bnd - left;
		    out_bound = right_bnd - right;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  }
		else
		  {
		  sig_width = left_bnd - right_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 1;
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 0;
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  }

		if ((out_bound - in_bound + 1) != expr1.WIDTH)
		  bvl_error (35,(yyvsp[-5].name).NAME);

		if (rev_flg == 1)
		  expr1.LIST_ABL = reverse (expr1.LIST_ABL);

		abl_pnt = expr1.LIST_ABL;

		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		    bvl_error (21,(yyvsp[-5].name).NAME);
		    break;

		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		    if ((yyvsp[-3].valu) == BVL_GRDDFN)
		      bvl_error (22,(yyvsp[-5].name).NAME);
		    beout_pnt = (struct beout *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beout_pnt->ABL != NULL)
		            bvl_error (39,beout_pnt->NAME);
		          else
		            beout_pnt->ABL = (struct chain *)abl_pnt->DATA;
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beout_pnt = beout_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bebus_pnt = (struct bebus *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebus_pnt->BINODE = beh_addbinode (bebus_pnt->BINODE,
		                                             NULL,NULL);
		          bebus_pnt->BIABL  = beh_addbiabl  (bebus_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebus_pnt = bebus_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_BITDFN + BVL_NORDFN):
		    if ((yyvsp[-3].valu) == BVL_GRDDFN)
		      bvl_error (22,(yyvsp[-5].name).NAME);
		    beaux_pnt = (struct beaux *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beaux_pnt->ABL != NULL)
		            bvl_error (39,beaux_pnt->NAME);
		          else
		           {
		            beaux_pnt->ABL = (struct chain *)abl_pnt->DATA;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beaux_pnt = beaux_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_RBIDFN + BVL_REGDFN):
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bereg_pnt = (struct bereg *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bereg_pnt->BINODE = beh_addbinode (bereg_pnt->BINODE,
		                                             NULL,NULL);
		          bereg_pnt->BIABL  = beh_addbiabl  (bereg_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bereg_pnt = bereg_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_WORDFN + BVL_BUSDFN) :
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bebux_pnt = (struct bebux *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebux_pnt->BINODE = beh_addbinode (bebux_pnt->BINODE,
		                                             NULL,NULL);
		          bebux_pnt->BIABL  = beh_addbiabl  (bebux_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebux_pnt = bebux_pnt->NEXT;
		        }
		      }
		    break;

		  default :
		    bvl_error (17,(yyvsp[-5].name).NAME);
		    break;
		  }
		}
#line 2908 "y.tab.c"
    break;

  case 85:
#line 1390 "./bvl_bcomp_y.y"
                { (yyval.list) = BVL_EMPSTR; }
#line 2914 "y.tab.c"
    break;

  case 86:
#line 1394 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_OR,(yyvsp[-2].list),(yyvsp[0].list),-1,-1); }
#line 2920 "y.tab.c"
    break;

  case 87:
#line 1401 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;

		bvl_select (&expr1,BVL_NM1LST,&BVL_BDDPNT,BVL_SLCEXP);
		freechain (BVL_NM1LST);
		BVL_NM1LST = NULL;

		(yyval.list) = bvl_crtabl (ANDM,(yyvsp[-2].list),expr1,-1,-1);
		}
#line 2934 "y.tab.c"
    break;

  case 88:
#line 1414 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2940 "y.tab.c"
    break;

  case 89:
#line 1420 "./bvl_bcomp_y.y"
                {
		(yyval.list)      = (yyvsp[-1].list);
		}
#line 2948 "y.tab.c"
    break;

  case 90:
#line 1427 "./bvl_bcomp_y.y"
                {}
#line 2954 "y.tab.c"
    break;

  case 91:
#line 1430 "./bvl_bcomp_y.y"
                {}
#line 2960 "y.tab.c"
    break;

  case 92:
#line 1436 "./bvl_bcomp_y.y"
                {}
#line 2966 "y.tab.c"
    break;

  case 93:
#line 1441 "./bvl_bcomp_y.y"
                {}
#line 2972 "y.tab.c"
    break;

  case 94:
#line 1443 "./bvl_bcomp_y.y"
                {}
#line 2978 "y.tab.c"
    break;

  case 95:
#line 1445 "./bvl_bcomp_y.y"
                {}
#line 2984 "y.tab.c"
    break;

  case 96:
#line 1447 "./bvl_bcomp_y.y"
                {}
#line 2990 "y.tab.c"
    break;

  case 97:
#line 1449 "./bvl_bcomp_y.y"
                {}
#line 2996 "y.tab.c"
    break;

  case 98:
#line 1454 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (NULL ,(yyvsp[0].text)); }
#line 3002 "y.tab.c"
    break;

  case 99:
#line 1456 "./bvl_bcomp_y.y"
                { yyerrok; }
#line 3008 "y.tab.c"
    break;

  case 101:
#line 1464 "./bvl_bcomp_y.y"
                {
        if (!strncmp((yyvsp[0].text),"others",7))
		  bvl_error (30,NULL);
		BVL_NM1LST = addchain (BVL_NM1LST ,(yyvsp[0].text));
		}
#line 3018 "y.tab.c"
    break;

  case 102:
#line 1473 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3024 "y.tab.c"
    break;

  case 103:
#line 1475 "./bvl_bcomp_y.y"
                { (yyval.text) = "others"; }
#line 3030 "y.tab.c"
    break;

  case 104:
#line 1477 "./bvl_bcomp_y.y"
                {
		char           *val;
		char            val2[256];
		long             left;
		long             right;
		long             in_bound;
		long             out_bound;
		long             left_bnd;
		long             right_bnd;
		long             sig_conf;

		strcpy (val2,"B\"");
		sig_conf = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_SIGDFN);
		val      = (char *) beh_chktab (dic,(yyvsp[0].name).NAME,NULL,BVL_PNTDFN);
		if (sig_conf == 0)
		  bvl_error (17,(yyvsp[0].name).NAME);
		else
		  {
		  if (sig_conf != BVL_CSTDFN)
		    bvl_error (76,(yyvsp[0].name).NAME);
		  }

		left_bnd  = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_WMNDFN);
		right_bnd = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_WMXDFN);

		left  = (yyvsp[0].name).LEFT;
		right = (yyvsp[0].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  if (left <= right)
		    {
		    in_bound = left - left_bnd;
		    out_bound = right - left_bnd;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound = left - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  }
		else
		  {
		  if (left <= right)
		    {
		    in_bound = right - left_bnd;
		    out_bound = left - left_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound = right - right_bnd;
		    out_bound = left - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  }

		bvl_tobin (&val2[2],val,in_bound,out_bound);
		strcat (val2,"\"");
		(yyval.text) = namealloc (val2);
		}
#line 3102 "y.tab.c"
    break;

  case 105:
#line 1548 "./bvl_bcomp_y.y"
                { (yyval.text) = NULL; }
#line 3108 "y.tab.c"
    break;

  case 106:
#line 1551 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3114 "y.tab.c"
    break;

  case 107:
#line 1556 "./bvl_bcomp_y.y"
                { (yyval.valu) = 'E'; }
#line 3120 "y.tab.c"
    break;

  case 108:
#line 1559 "./bvl_bcomp_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3126 "y.tab.c"
    break;

  case 109:
#line 1564 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3132 "y.tab.c"
    break;

  case 110:
#line 1569 "./bvl_bcomp_y.y"
                { (yyval.valu) = 'E'; }
#line 3138 "y.tab.c"
    break;

  case 111:
#line 1571 "./bvl_bcomp_y.y"
                { (yyval.valu) = 'W'; }
#line 3144 "y.tab.c"
    break;

  case 112:
#line 1576 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3150 "y.tab.c"
    break;

  case 113:
#line 1578 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3156 "y.tab.c"
    break;

  case 114:
#line 1580 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3162 "y.tab.c"
    break;

  case 115:
#line 1582 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3168 "y.tab.c"
    break;

  case 116:
#line 1589 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_AND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3174 "y.tab.c"
    break;

  case 117:
#line 1593 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_AND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3180 "y.tab.c"
    break;

  case 118:
#line 1600 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_OR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3186 "y.tab.c"
    break;

  case 119:
#line 1604 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_OR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3192 "y.tab.c"
    break;

  case 120:
#line 1609 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3198 "y.tab.c"
    break;

  case 121:
#line 1613 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_NAND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3204 "y.tab.c"
    break;

  case 122:
#line 1617 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_NOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3210 "y.tab.c"
    break;

  case 123:
#line 1625 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_XOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3216 "y.tab.c"
    break;

  case 124:
#line 1629 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_XOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3222 "y.tab.c"
    break;

  case 125:
#line 1634 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3228 "y.tab.c"
    break;

  case 126:
#line 1638 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl ((yyvsp[-1].valu) ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3234 "y.tab.c"
    break;

  case 127:
#line 1643 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3240 "y.tab.c"
    break;

  case 128:
#line 1648 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3246 "y.tab.c"
    break;

  case 129:
#line 1652 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (CONC,(yyvsp[-2].list),(yyvsp[0].list),-1,-1); }
#line 3252 "y.tab.c"
    break;

  case 130:
#line 1658 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3258 "y.tab.c"
    break;

  case 131:
#line 1663 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3264 "y.tab.c"
    break;

  case 132:
#line 1666 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_NOT,(yyvsp[0].list),BVL_EMPSTR,-1,-1); }
#line 3270 "y.tab.c"
    break;

  case 133:
#line 1671 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;
		expr1.IDENT = (yyvsp[0].text);
		(yyval.list) = bvl_crtabl (NOPS,expr1,BVL_EMPSTR,-1,-1);
		}
#line 3280 "y.tab.c"
    break;

  case 134:
#line 1677 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3286 "y.tab.c"
    break;

  case 135:
#line 1679 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;
		long             left;
		long             right;
		long             left_bnd;
		long             right_bnd;
		long             in_bound;
		long             out_bound;
		long             sig_conf;

		sig_conf = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_SIGDFN);
		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BITDFN + BVL_NORDFN):
		  case (BVL_MUXDFN + BVL_BUSDFN):
		  case (BVL_WORDFN + BVL_BUSDFN):
		  case (BVL_RBIDFN + BVL_REGDFN):
		  case (BVL_CSTDFN):
		    break;
		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    bvl_error (26,(yyvsp[0].name).NAME);
		    break;
		  default :
		    bvl_error (17,(yyvsp[0].name).NAME);
		    break;
		  }

		left_bnd  = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_WMNDFN);
		right_bnd = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_WMXDFN);

		left  = (yyvsp[0].name).LEFT;
		right = (yyvsp[0].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  if (left <= right)
		    {
		    in_bound  = left  - left_bnd;
		    out_bound = right - left_bnd;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound  = right - left_bnd;
		    out_bound = left  - left_bnd;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  }
		else
		  {
		  if (left <= right)
		    {
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  }

		if (sig_conf != BVL_CSTDFN)
		  {
		  expr1.IDENT = (yyvsp[0].name).NAME;
		  if((yyvsp[0].name).FLAG == 'X')
			{
		  	expr1 = bvl_crtabl (NOPI,expr1,BVL_EMPSTR,left,right);
		  	(yyval.list) = bvl_crtabl (ABL_STABLE,expr1,BVL_EMPSTR,left,right);
			}
		  else 
		  	(yyval.list) = bvl_crtabl (NOPI,expr1,BVL_EMPSTR,left,right);
		  }
		else
		  {
		  expr1.IDENT = (char *)beh_chktab(dic,(yyvsp[0].name).NAME,NULL,BVL_PNTDFN);
		  (yyval.list) = bvl_crtabl (NOPS,expr1,BVL_EMPSTR,in_bound,out_bound);
		  }
		}
#line 3382 "y.tab.c"
    break;

  case 136:
#line 1774 "./bvl_bcomp_y.y"
                { (yyval.valu) = EQ; }
#line 3388 "y.tab.c"
    break;

  case 137:
#line 1776 "./bvl_bcomp_y.y"
                { (yyval.valu) = NE; }
#line 3394 "y.tab.c"
    break;

  case 138:
#line 1781 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3400 "y.tab.c"
    break;

  case 139:
#line 1783 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3406 "y.tab.c"
    break;

  case 140:
#line 1785 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3412 "y.tab.c"
    break;

  case 141:
#line 1792 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[-1].list); }
#line 3418 "y.tab.c"
    break;

  case 142:
#line 1797 "./bvl_bcomp_y.y"
                {
		(yyval.name).NAME  = (yyvsp[0].text);
		(yyval.name).LEFT  = beh_chktab (dic,(yyvsp[0].text),BVL_MODNAM,BVL_WMNDFN);
		(yyval.name).RIGHT = beh_chktab (dic,(yyvsp[0].text),BVL_MODNAM,BVL_WMXDFN);
		}
#line 3428 "y.tab.c"
    break;

  case 143:
#line 1803 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 3434 "y.tab.c"
    break;

  case 144:
#line 1805 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 3440 "y.tab.c"
    break;

  case 145:
#line 1807 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 3446 "y.tab.c"
    break;

  case 146:
#line 1815 "./bvl_bcomp_y.y"
                {
		(yyval.name).NAME  = (yyvsp[-3].text);
		(yyval.name).LEFT  = (yyvsp[-1].valu);
		(yyval.name).RIGHT = (yyvsp[-1].valu);
		}
#line 3456 "y.tab.c"
    break;

  case 147:
#line 1829 "./bvl_bcomp_y.y"
                {
		if ((((yyvsp[-1].valu) > (yyvsp[-3].valu)) && ((yyvsp[-2].valu) != BVL_UPTDFN)) ||
		    (((yyvsp[-1].valu) < (yyvsp[-3].valu)) && ((yyvsp[-2].valu) != BVL_DWTDFN)))
		  bvl_error (32,(yyvsp[-5].text));

		(yyval.name).NAME  = (yyvsp[-5].text);
		(yyval.name).LEFT  = (yyvsp[-3].valu);
		(yyval.name).RIGHT = (yyvsp[-1].valu);
		}
#line 3470 "y.tab.c"
    break;

  case 148:
#line 1844 "./bvl_bcomp_y.y"
                {
		char             extname[100];
		char            *lclname;
		long              sig_conf;
		struct bvl_expr  expr1;
		struct bvl_expr  expr2;
		struct chain    *ptabl;

		sig_conf = beh_chktab (dic,(yyvsp[-2].text),BVL_MODNAM,BVL_SIGDFN);
		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BITDFN + BVL_NORDFN):
		  case (BVL_MUXDFN + BVL_BUSDFN):
		  case (BVL_WORDFN + BVL_BUSDFN):
		  case (BVL_RBIDFN + BVL_REGDFN):
		    break;
		  default :
		    bvl_error (79,(yyvsp[-2].text));
		  }

		if (beh_chktab (dic,(yyvsp[-2].text),BVL_MODNAM,BVL_WMNDFN) != -1)
		  bvl_error (79,(yyvsp[-2].text));

		sprintf (extname,"%s'delayed",(yyvsp[-2].text));
		lclname = namealloc (extname);

		if (BVL_ERRFLG == 0)
		  {
		  if (beh_chktab (dic,(yyvsp[-2].text),BVL_MODNAM,BVL_STBDFN) == 0)
		    {
		    expr1.IDENT = (yyvsp[-2].text);
		    expr1.WIDTH  = 1;
		    expr2 = bvl_crtabl (NOPI,expr1,BVL_EMPSTR,-1,-1);
		    ptabl = expr2.LIST_ABL->DATA;

		    if (BVL_AUXMOD == 1)
		      BVL_BEFPNT->BERIN=beh_addberin(BVL_BEFPNT->BERIN,lclname);

		    BVL_BEFPNT->BEDLY = beh_addbeaux(BVL_BEFPNT->BEDLY,lclname,
		                                     ptabl,NULL);
		    beh_addtab (dic,(yyvsp[-2].text)     ,BVL_MODNAM,BVL_STBDFN,1);
		    beh_addtab (dic,lclname,BVL_MODNAM,BVL_WMNDFN,-1);
		    beh_addtab (dic,lclname,BVL_MODNAM,BVL_WMXDFN,-1);
		    beh_addtab (dic,lclname,BVL_MODNAM,BVL_SIGDFN,
		                (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN));
		    }
		  }
		BVL_BEFPNT->TYPE |= BEH_STABLE;
		(yyval.name).NAME = (yyvsp[-2].text);
		(yyval.name).LEFT = -1;
		(yyval.name).RIGHT = -1;
		(yyval.name).FLAG  = 'X';

		}
#line 3533 "y.tab.c"
    break;

  case 150:
#line 1910 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = BIT; (yyval.dble).FLAG = 'S'; }
#line 3539 "y.tab.c"
    break;

  case 151:
#line 1912 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = WOR_BIT; (yyval.dble).FLAG = 'S'; }
#line 3545 "y.tab.c"
    break;

  case 152:
#line 1914 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = MUX_BIT; (yyval.dble).FLAG = 'S'; }
#line 3551 "y.tab.c"
    break;

  case 153:
#line 1916 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = BIT; (yyval.dble).FLAG = 'A'; }
#line 3557 "y.tab.c"
    break;

  case 154:
#line 1918 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = WOR_BIT; (yyval.dble).FLAG = 'A'; }
#line 3563 "y.tab.c"
    break;

  case 155:
#line 1920 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = MUX_BIT; (yyval.dble).FLAG = 'A'; }
#line 3569 "y.tab.c"
    break;

  case 156:
#line 1922 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = REG_BIT; (yyval.dble).FLAG = 'S'; }
#line 3575 "y.tab.c"
    break;

  case 157:
#line 1924 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = REG_BIT; (yyval.dble).FLAG = 'A'; }
#line 3581 "y.tab.c"
    break;

  case 158:
#line 1926 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = NATURAL; (yyval.dble).FLAG = 'S'; }
#line 3587 "y.tab.c"
    break;

  case 159:
#line 1928 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = NATURAL; (yyval.dble).FLAG = 'A'; }
#line 3593 "y.tab.c"
    break;

  case 160:
#line 1933 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (BVL_NM1LST,(yyvsp[0].text)); }
#line 3599 "y.tab.c"
    break;

  case 163:
#line 1942 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (BVL_NM1LST,(yyvsp[0].text)); }
#line 3605 "y.tab.c"
    break;

  case 164:
#line 1947 "./bvl_bcomp_y.y"
                { (yyval.text) = NULL; }
#line 3611 "y.tab.c"
    break;

  case 165:
#line 1949 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3617 "y.tab.c"
    break;

  case 166:
#line 1954 "./bvl_bcomp_y.y"
                { (yyval.text) = NULL; }
#line 3623 "y.tab.c"
    break;

  case 167:
#line 1956 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3629 "y.tab.c"
    break;

  case 168:
#line 1963 "./bvl_bcomp_y.y"
                { (yyval.text) = (char *)(yyvsp[-1].list).LIST_ABL->DATA; }
#line 3635 "y.tab.c"
    break;

  case 169:
#line 1968 "./bvl_bcomp_y.y"
                { (yyval.valu) = BVL_UNGDFN ; }
#line 3641 "y.tab.c"
    break;

  case 170:
#line 1970 "./bvl_bcomp_y.y"
                { (yyval.valu) = BVL_GRDDFN; }
#line 3647 "y.tab.c"
    break;

  case 171:
#line 1975 "./bvl_bcomp_y.y"
                { (yyval.text) = NULL; }
#line 3653 "y.tab.c"
    break;

  case 172:
#line 1977 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3659 "y.tab.c"
    break;

  case 173:
#line 1982 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3665 "y.tab.c"
    break;

  case 174:
#line 1987 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 3671 "y.tab.c"
    break;

  case 175:
#line 1993 "./bvl_bcomp_y.y"
                {
		BVL_LBLNAM = (yyvsp[-1].text);
		(yyval.text) = (yyvsp[-1].text);
		}
#line 3680 "y.tab.c"
    break;

  case 176:
#line 2001 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3686 "y.tab.c"
    break;

  case 177:
#line 2006 "./bvl_bcomp_y.y"
                { (yyval.valu) = atoi ((yyvsp[0].text)); }
#line 3692 "y.tab.c"
    break;

  case 178:
#line 2011 "./bvl_bcomp_y.y"
                { yyerrok; }
#line 3698 "y.tab.c"
    break;

  case 179:
#line 2016 "./bvl_bcomp_y.y"
                { yyerrok; }
#line 3704 "y.tab.c"
    break;

  case 180:
#line 2021 "./bvl_bcomp_y.y"
                { yyerrok; }
#line 3710 "y.tab.c"
    break;


#line 3714 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2023 "./bvl_bcomp_y.y"


void *addstr (

struct befig *ptfig,
char          object,
long           mode,
long           type,
char          flag,
char         *name,
short         left,
short         right )

  {
  void  *pnt    = NULL;
  char   porflg = 0;
  char   rinflg = 0;
  char   outflg = 0;
  char   busflg = 0;
  char   auxflg = 0;
  char   buxflg = 0;
  char   regflg = 0;
  char   lclmod = 0;
  char   lcltyp = 0;
  char   extname[100];
  short  i;
  short  inc = 1;

  switch (object)
    {
    case 'P':

	/* ###------------------------------------------------------### */
	/*   if object is a port ...					*/
	/* ###------------------------------------------------------### */

      porflg = 1;
      switch (mode)
        {
        case _IN:
          lclmod = 'I'; lcltyp = 'B'; rinflg = 1; break;
        case _OUT:
          switch (type)
            {
            case BIT:
              lclmod = 'O'; lcltyp = 'B'; outflg = 1; break;
            case MUX_BIT:
              lclmod = 'Z'; lcltyp = 'M'; busflg = 1; break;
            case WOR_BIT:
              lclmod = 'Z'; lcltyp = 'W'; busflg = 1; break;
            }
          break;
        case _INOUT:
          rinflg = 1;
          switch (type)
            {
            case BIT:
              lclmod = 'B'; lcltyp = 'B'; outflg = 1; break;
            case MUX_BIT:
              lclmod = 'T'; lcltyp = 'M'; busflg = 1; break;
            case WOR_BIT:
              lclmod = 'T'; lcltyp = 'W'; busflg = 1; break;
            }
          break;
        }
      break;

    case 'S':

	/* ###------------------------------------------------------### */
	/*   if object is a signal ...					*/
	/* ###------------------------------------------------------### */

      switch (type)
        {
        case BIT:
          lcltyp = 'B'; rinflg = BVL_AUXMOD; auxflg = 1; break;
        case REG_BIT:
          rinflg = 1; regflg = 1; break;
        case MUX_BIT:
          lcltyp = 'M'; rinflg = 1; buxflg = 1; break;
        case WOR_BIT:
          lcltyp = 'W'; rinflg = 1; buxflg = 1; break;
        }
      break;
    }

  if (flag == 'S')
    {
	/* ###------------------------------------------------------### */
	/*   if object is a scalar ...					*/
	/* ###------------------------------------------------------### */

    if (porflg == 1)
      ptfig->BEPOR = beh_addbepor (ptfig->BEPOR,name,lclmod,lcltyp);
    if (rinflg == 1)
      ptfig->BERIN = beh_addberin (ptfig->BERIN,name);
    if (outflg == 1)
      ptfig->BEOUT = beh_addbeout (ptfig->BEOUT,name,NULL,NULL);
    if (busflg == 1)
      ptfig->BEBUS = beh_addbebus (ptfig->BEBUS,name,NULL,NULL,lcltyp);
    if (auxflg == 1)
      ptfig->BEAUX = beh_addbeaux (ptfig->BEAUX,name,NULL,NULL);
    if (buxflg == 1)
      ptfig->BEBUX = beh_addbebux (ptfig->BEBUX,name,NULL,NULL,lcltyp);
    if (regflg == 1)
      ptfig->BEREG = beh_addbereg (ptfig->BEREG,name,NULL,NULL);

    }
  else
    {
	/* ###------------------------------------------------------### */
	/*   if object is an array ...					*/
	/* ###------------------------------------------------------### */

    if (left >= right)
      inc = -1;

    for (i=left ; i!=(right+inc) ; i+=inc)
      {
      sprintf (extname,"%s %d",name,i);

      if (porflg == 1)
        ptfig->BEPOR = beh_addbepor (ptfig->BEPOR,extname,lclmod,lcltyp);
      if (rinflg == 1)
        ptfig->BERIN = beh_addberin (ptfig->BERIN,extname);
      if (outflg == 1)
        ptfig->BEOUT = beh_addbeout (ptfig->BEOUT,extname,NULL,NULL);
      if (busflg == 1)
        ptfig->BEBUS = beh_addbebus (ptfig->BEBUS,extname,NULL,NULL,lcltyp);
      if (auxflg == 1)
        ptfig->BEAUX = beh_addbeaux (ptfig->BEAUX,extname,NULL,NULL);
      if (buxflg == 1)
        ptfig->BEBUX = beh_addbebux (ptfig->BEBUX,extname,NULL,NULL,lcltyp);
      if (regflg == 1)
        ptfig->BEREG = beh_addbereg (ptfig->BEREG,extname,NULL,NULL);
      }
    }

  if (outflg == 1)
    pnt = (void *) ptfig->BEOUT;
  if (busflg == 1)
    pnt = (void *) ptfig->BEBUS;
  if (auxflg == 1)
    pnt = (void *) ptfig->BEAUX;
  if (buxflg == 1)
    pnt = (void *) ptfig->BEBUX;
  if (regflg == 1)
    pnt = (void *) ptfig->BEREG;

  return (pnt);
  }

static long 
chkdcl (
char object,
long  mode,
long  type,
char flag,
long  kind,
char constraint,
long  *conf  )

  {
  long errflg = 0;
  long lclcnf = 0;

  if (flag != constraint)
    {
    errflg = 1;
    bvl_error (33,NULL);
    }
  else
    {
    switch (object)
      {
      case 'P':
	/* ###------------------------------------------------------### */
	/*    If object is a port :					*/
	/*       - if type is bit, no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT:

            lclcnf += BVL_BITDFN + BVL_NORDFN;
            switch (mode)
              {
              case _IN :
                lclcnf += BVL_ICNDFN; break;
              case _OUT:
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != 0)
              errflg = 1;
            break;

          case MUX_BIT:

            lclcnf += BVL_MUXDFN + BVL_BUSDFN;
            switch (mode)
              {
              case _OUT :
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _IN :
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case WOR_BIT:

            lclcnf += BVL_WORDFN + BVL_BUSDFN;
            switch (mode)
              {
              case _OUT :
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _IN :
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case REG_BIT:
          case NATURAL:

            errflg = 1;
            break;
          }
        if (errflg == 1)
          bvl_error (5,NULL);
        break;

      case 'G':
	/* ###------------------------------------------------------### */
	/*    If object is a generic :					*/
	/*       - only natural type is allowed				*/
	/* ###------------------------------------------------------### */

        if ((type != NATURAL) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          bvl_error (77,NULL);
          }
        break;

      case 'S':
	/* ###------------------------------------------------------### */
	/*    If object is a signal :					*/
	/*       - no mode can be specified				*/
	/*       - if type is bit no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - if type is reg_bit, register kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT:
            lclcnf += BVL_BITDFN + BVL_NORDFN;
            if ((mode != 0) || (kind != 0))
              errflg = 1;
            break;
          case MUX_BIT:
            lclcnf += BVL_MUXDFN + BVL_BUSDFN;
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case WOR_BIT:
            lclcnf += BVL_WORDFN + BVL_BUSDFN;
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case REG_BIT:
            lclcnf += BVL_RBIDFN + BVL_REGDFN;
            if ((mode != 0) || (kind != REGISTER))
              errflg = 1;
            break;
          case NATURAL:
            errflg = 1; break;
          }

        if (mode != 0)
          errflg = 1;

        if (errflg == 1)
          bvl_error (11,NULL);
        break;

      case 'C':
	/* ###------------------------------------------------------### */
	/*    If object is a constant :					*/
	/*       - only bit type without any other indication is legal	*/
	/* ###------------------------------------------------------### */

        lclcnf += BVL_CSTDFN;
        if ((type != BIT) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          bvl_error (78,NULL);
          }
        break;
      }
    }

  *conf = lclcnf ;
  return (errflg);
  }
